/*              Tarea N3
Asignatura:     Programacion de Sistemas
Proyecto:       Monitor de trafico para Browser
NOMBRE:		mtb.h
SINOPSIS:	mtb <Puerto_Local> <IP_Proxy> <Puerto_Proxy>
DESCRIPCION:	Programa que funciona como servidor transparente entre el (browser) y el verdadero
	        Proxy que sale a internet. Ademas monitorea el trafico de Rx , Tx y Numero de
                conexiones
Alumnos:        Diego Gonzalez Barrientos
                Patricio Valle Vidal
*/

/*------------------------------------------------*/
/*Librerias incluidas y requeridas en el programa */
/*------------------------------------------------*/
 
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netdb.h>

/*------------------------------------------------*/
/*Constantes empleadas en el programa             */
/*------------------------------------------------*/


//Datos de la ventana grafica
#define  WINDOW_SIZE   120 //Tamano de la Ventana grafica
#define  WINDOW_REFRESH 60 //Tiempo de refresco de la ventan grafica

/*------------------------------------------------*/
/*Variables Globales requeridas en el programa    */
/*------------------------------------------------*/

pid_t pid; //Usado para identificar a los procesos
int enable = 0; //Utilizado para diferenciar entre datos de Tx y Rx
int bytesTX = 0; //Utilizado para contar el numero de datos a ser Tx por conexion
int bytesRX = 0; //Utilizado para contar el numero de datos a ser Rx por conexion
int alarm_counter = WINDOW_SIZE;  //Contador para actualizar el tamano de la ventana movil
int alarm_refresh = WINDOW_REFRESH; //Contador para actualizar el tamono de la ventana movil
int time_counter = 0; //Contador de los segundos que han avanzado para graficar datos
int Nconex = 0; //Variable usada para contar las conexiones por segundo
int pfd[2]; //Variables usadas para definir pipa con scilab 
int inside = 0; //Variable usada para utilizar solo una ventana grafica
int status; 
FILE *sd; //Descriptor de archivo empleado para enviar datos a la entrada de la pipa

/*------------------------------------------------*/
/*Estructuras requeridas en el programa           */
/*------------------------------------------------*/

//Estructura grafica usada para almacenar datos por segundo
struct grafica
{
   int NumConex; //Numero de conexiones en un segundo
   int Tx;       //Datos Tx en un segundo 
   int Rx;       //Datos Rx en un segundo
} Ventana[WINDOW_SIZE]; //Arreglo de estructura del tamano de la ventana

/*--------------------------------------------------*/
/*Prototipos de Funciones requeridas en el programa */
/*--------------------------------------------------*/

//Prototipos de funciones
void err_sys(char * msg); //Funcion manejador de errores en registro de 
                          //funciones de manejo de senales
static void  sig_int(int signo); //Funcion de manejo de senal control+c
static void sig_alrm(int signo); //Funcion de manejo de senal alarm
void reusePort(int s); //Funcion para reutilizar el socket
int SocketConnector(int lector, int escritor, int enable); //Funcion utilizada para la conexion
                                                           //Cliente-Proxy
